CREATE OR REPLACE PROCEDURE CTB_DFS_IMPOSTO(
   P_NRLANCTBTEMP IN LANCCONT.NRLANCCONT%TYPE,
   P_CDFILIAL IN FILIAL.CDFILIAL%TYPE,
   P_NRLANCTONF IN NOTAFISCAL.NRLANCTONF%TYPE,
   P_IDDEVOLUCAO IN CONTCTBL.IDTIPOCONT%TYPE,
   P_VRLANCTO IN OUT LANCCONT.VRLANCAMENT%TYPE)
AS
   V_COUNT INT;
   V_NRSEQLANC LANCCONT.NRSEQLANC%TYPE;
   V_DIFALIQ LANCCONT.VRLANCAMENT%TYPE;
   V_CDHISTPADR HISTPADR.CDHISTPADR%TYPE;
   V_DSHISTLANC LANCCONT.DSHISTLANC%TYPE;
   V_NUMPARTIDA INT;
   V_IDCOME VARCHAR2(01);
   V_IDCCUS VARCHAR2(01);
   V_CDCOMERCIAL FORNECEDOR.CDFORNECED%TYPE;
   V_CDCOMERCIALAUX FORNECEDOR.CDFORNECED%TYPE;
   V_CDCENTCUST CENTCUST.CDCENTCUST%TYPE;
   V_CDFILIAL FILIAL.CDFILIAL%TYPE;
   V_CONTCCUS VARCHAR2(01);
   V_ACUMULA VARCHAR2(01);
   V_CONTAATIV CONTCTBL.CDCONTCTBL%TYPE;
   V_CONTAPASS CONTCTBL.CDCONTCTBL%TYPE;
   V_CONTADESP CONTCTBL.CDCONTCTBL%TYPE;
   V_CDIMPOSTRIB IMPOSTO.CDIMPOSTO%TYPE;
   V_CONTA CONTCTBL.CDCONTCTBL%TYPE;
   V_CONTATIPOOPER CONTCTBL.CDCONTCTBL%TYPE;
   V_CDARVPROD PRODUTO.CDARVPROD%TYPE;
   V_CDMODFISCAL MODDOCFISC.CDMODDOCFISC%TYPE;
   V_ENTROULOOP VARCHAR2(01);
   V_VRRATEIO LANCCONT.VRLANCAMENT%TYPE;
   V_VRPARTIDA LANCCONT.VRLANCAMENT%TYPE;
   V_CDIMPOSUBST VARCHAR2(02);
   V_CDCONTPROD CONTCTBL.CDCONTCTBL%TYPE;
   V_IMPOSCARGATRIB VARCHAR2(02);
   V_VRCARGATRIB LANCCONT.VRLANCAMENT%TYPE;
   
   PROCEDURE NUMEROPARTIDA(P_CDEMPRESA IN EMPRESA.CDEMPRESA%TYPE,
                           P_IDORIGDESTNF IN NOTAFISCAL.IDORIGDESTNF%TYPE,
                           P_CDFORNECED IN FORNECEDOR.CDFORNECED%TYPE,
                           P_CDCLIENTE IN CLIENTE.CDCLIENTE%TYPE)
   AS
   BEGIN
      IF V_NUMPARTIDA IS NULL THEN
         /* NUMERO DA PARTIDA */
         BEGIN
            SELECT TO_NUMBER(MAX(NRSEQCTBTEMP))
              INTO V_NUMPARTIDA
              FROM LANCCTBTEMP
             WHERE NRLANCCTBTEMP = P_NRLANCTBTEMP
               AND CDEMPRESA = P_CDEMPRESA;
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
               V_NUMPARTIDA := 0;
         END;

         IF V_NUMPARTIDA IS NULL THEN
            V_NUMPARTIDA := 0;
         END IF;

         /* CONTROLA SE GERA OS RATEIOS - CONTROLA SE AS PARTIDAS ACUMULAM */
         SELECT IDCONTGERE, IDACUMVRCONT
           INTO V_CONTCCUS, V_ACUMULA
           FROM CONTOPECTBL
          WHERE CDEMPRESA = P_CDEMPRESA;
         /* BUSCA O CODIGO COMERCIAL */
         BEGIN
            SELECT DECODE(P_IDORIGDESTNF, 'F', P_CDFORNECED, DECODE(P_IDORIGDESTNF, 'C', P_CDCLIENTE, NULL))
              INTO V_CDCOMERCIAL
              FROM DUAL;
          EXCEPTION
            WHEN NO_DATA_FOUND THEN
               V_CDCOMERCIAL := NULL;
         END;
      END IF;
   END;
   PROCEDURE PARTIDA(P_CDEMPRESA IN EMPRESA.CDEMPRESA%TYPE,
                     P_CDFILIAL IN FILIAL.CDFILIAL%TYPE,
                     P_CDFILIRECE IN FILIAL.CDFILIAL%TYPE,
                     P_CDFILIEMIT IN FILIAL.CDFILIAL%TYPE,
                     P_NRLANCTONF IN NOTAFISCAL.NRLANCTONF%TYPE,
                     P_NRNOTAFISC IN NOTAFISCAL.NRNOTAFISC%TYPE,
                     P_IDENTRSAID IN NOTAFISCAL.IDENTRSAIDOP%TYPE,
                     P_IDORIGDESTNF IN NOTAFISCAL.IDORIGDESTNF%TYPE,
                     P_CDFORNECED IN NOTAFISCAL.CDFORNECED%TYPE,
                     P_CDCLIENTE IN NOTAFISCAL.CDCLIENTE%TYPE,
                     P_DTENTRSAID IN NOTAFISCAL.DTENTRSAID%TYPE,
                     P_SINAL IN INT,
                     P_CDCONTCTBL IN CONTCTBL.CDCONTCTBL%TYPE,
                     P_IDFILIAL IN CONTCTBL.IDTIPOCONT%TYPE,
                     P_VRPARTIDA IN LANCCONT.VRLANCAMENT%TYPE)
   AS
   BEGIN
      BUSCA_TPCOMERCIAL(P_CDCONTCTBL, V_IDCOME, V_IDCCUS);
      IF P_IDFILIAL = 'S' THEN
         V_CDCENTCUST := BUSCA_CCUSTO(P_CDFILIEMIT, P_CDEMPRESA);
      ELSE
         V_CDCENTCUST := BUSCA_CCUSTO(P_CDFILIRECE, P_CDEMPRESA);
      END IF;

      BEGIN
         SELECT COUNT(*)
           INTO V_COUNT
           FROM LANCCTBTEMP
          WHERE CDEMPRESA = P_CDEMPRESA
            AND NRLANCCTBTEMP = P_NRLANCTBTEMP
            AND CDCONTCTBL = P_CDCONTCTBL;
      EXCEPTION
         WHEN NO_DATA_FOUND THEN
            V_COUNT := 0;
      END;

      V_CDCOMERCIALAUX := V_CDCOMERCIAL;
      IF V_IDCOME = 'N' THEN
         V_CDCOMERCIALAUX := NULL;
      END IF;
      /* CASO NO EXISTA PARTIDA PARA A CONTA CONTBIL,  FEITA UMA */
      IF V_COUNT = 0 THEN
         V_NUMPARTIDA := V_NUMPARTIDA + 1;
         INSERT INTO LANCCTBTEMP
            (CDEMPRESA, NRLANCCTBTEMP, CDDOCUTEMP, NRSEQCTBTEMP,
             CDCONTCTBL, CDHISTPADR,    DSHISTCTB, DTLANCCTBTEMP,
             VRLANCCTBTEMP, IDLANCCTBCOME, CDLANCCTBCOME, IDSISTEMA)
         VALUES
            (P_CDEMPRESA, P_NRLANCTBTEMP, P_NRNOTAFISC, LPAD(TO_CHAR(V_NUMPARTIDA),5,'0'),
             P_CDCONTCTBL, V_CDHISTPADR, V_DSHISTLANC, P_DTENTRSAID, P_SINAL * (ROUND(P_VRPARTIDA, 2)), V_IDCOME, V_CDCOMERCIALAUX, 'DFS');
         IF V_CONTCCUS <> 'N' THEN
            IF V_IDCCUS <> 'O' THEN
               INSERT INTO RATECTBTEMP
                  (CDEMPRESA, NRLANCCTBTEMP, NRSEQCTBTEMP, CDFILIAL,
                   CDCENTCUST, VRRATECTBTEMP, DTCOMPCTBTEMP, NRSEQRATTEMP)
               VALUES
                  (P_CDEMPRESA, P_NRLANCTBTEMP, LPAD(TO_CHAR(V_NUMPARTIDA),5,'0'), DECODE(P_IDFILIAL, 'E', P_CDFILIRECE, P_CDFILIEMIT),
                   V_CDCENTCUST, P_SINAL * (ROUND(P_VRPARTIDA, 2) ), P_DTENTRSAID, '00001');
            END IF;
         END IF;
      ELSE
         /* CASO EXISTA ALGUMA PARTIDA, O VALOR DA MESMA  SOMENTE ATUALIZADO. */
         UPDATE LANCCTBTEMP
            SET VRLANCCTBTEMP = VRLANCCTBTEMP + (P_SINAL * (ROUND(P_VRPARTIDA, 2)))
          WHERE CDEMPRESA = P_CDEMPRESA
            AND NRLANCCTBTEMP = P_NRLANCTBTEMP
            AND CDCONTCTBL = P_CDCONTCTBL;
         /* SE A EMPRESA USAR A CONTABILIDADE GERENCIAL E A CONTA FOR DIFERENTE DE S OFICIAL, A ROTINA
            DE RATEIOS  FEITA */
         IF V_CONTCCUS <> 'N' THEN
            IF V_IDCCUS <> 'O' THEN
               BEGIN
                  SELECT COUNT(*), L.NRSEQCTBTEMP
                    INTO V_COUNT, V_NRSEQLANC
                    FROM LANCCTBTEMP L, RATECTBTEMP R
                   WHERE L.CDEMPRESA = P_CDEMPRESA
                     AND L.NRLANCCTBTEMP = P_NRLANCTBTEMP
                     AND L.CDEMPRESA = R.CDEMPRESA
                     AND L.NRSEQCTBTEMP = R.NRSEQCTBTEMP
                     AND L.CDCONTCTBL = P_CDCONTCTBL
                     AND R.CDFILIAL = DECODE(P_IDFILIAL, 'E', P_CDFILIRECE, P_CDFILIEMIT)
                     AND R.CDCENTCUST = V_CDCENTCUST
                   GROUP BY L.NRSEQCTBTEMP;
               EXCEPTION
                  WHEN NO_DATA_FOUND THEN
                     V_COUNT := 0;
                     V_NRSEQLANC := NULL;
               END;
               /* SE J EXISTIR PARTIDA PARA AQUELA CONTA CONTBIL COM A FILIAL E O CENTRO DE CUSTO, O VALOR  SOMENTE
                  ATUALIZADO. */
               IF V_COUNT = 0 THEN
                  INSERT INTO RATECTBTEMP
                     (CDEMPRESA, NRLANCCTBTEMP, NRSEQCTBTEMP, CDFILIAL,
                      CDCENTCUST, VRRATECTBTEMP, DTCOMPCTBTEMP, NRSEQRATTEMP)
                  VALUES
                     (P_CDEMPRESA, P_NRLANCTBTEMP, LPAD(TO_CHAR(V_NUMPARTIDA),5,'0'), DECODE(P_IDFILIAL, 'E', P_CDFILIRECE, P_CDFILIEMIT),
                      V_CDCENTCUST, P_SINAL * (ROUND(P_VRPARTIDA, 2)), P_DTENTRSAID, '00001');
               ELSE
                  UPDATE RATECTBTEMP
                     SET VRRATECTBTEMP = VRRATECTBTEMP + (P_SINAL * (ROUND(P_VRPARTIDA, 2)))
                   WHERE NRLANCCTBTEMP = P_NRLANCTBTEMP
                     AND CDEMPRESA = P_CDEMPRESA
                     AND NRSEQCTBTEMP = V_NRSEQLANC
                     AND CDFILIAL = DECODE(P_IDFILIAL, 'E', P_CDFILIRECE,  P_CDFILIEMIT)
                     AND CDCENTCUST = V_CDCENTCUST;
               END IF;
            END IF;
         END IF;
      END IF;
   END;
   
   FUNCTION CONTAPRODUTOIPI(P_CDPRODUTO IN PRODUTO.CDPRODUTO%TYPE,
                            P_IDENTRSAIDOP IN TIPOOPERAC.IDENTRSAIDOP%TYPE,
                            P_CDTIPOOPER IN TIPOOPERAC.CDTIPOOPER%TYPE,
                            P_CDFILIEMIT IN FILIAL.CDFILIAL%TYPE) RETURN VARCHAR2
   AS
      V_CDCONTPRODIPI CONTCTBL.CDCONTCTBL%TYPE;
      V_CDARVPROD PRODUTO.CDARVPROD%TYPE;
   BEGIN
      BEGIN
         SELECT P.CDARVPROD
           INTO V_CDARVPROD
           FROM PRODUTO P
          WHERE P.CDPRODUTO = P_CDPRODUTO;
      EXCEPTION
         WHEN NO_DATA_FOUND THEN
            V_CDARVPROD := NULL;
      END;
      /* APS BUSCAR A CHAVE DA TABELA PRODUTO,  BUSCADO A CONTA CONTBIL DO PRODUTO POR TIPO
         DE OPERO.
         TABELA: CTBPRDTPOPER
         CAMPO: CDCTBLPRODTO */
      BEGIN
         SELECT C.CDCTBLPRODTO
           INTO V_CDCONTPRODIPI
           FROM CTBPRDTPOPER C, (SELECT MAX(P.CDARVPROD) CDARVPROD
                                   FROM CTBPRDTPOPER A, PRODUTO P
                                  WHERE IDENTRSAIDOP = P_IDENTRSAIDOP
                                    AND CDTIPOOPER = P_CDTIPOOPER
                                    AND P.CDPRODUTO  =  A.CDPRODUTO
                                    AND (INSTR(V_CDARVPROD, RTRIM(P.CDARVPROD)) = 1)
                                    AND A.CDCTBLPRODTO IS NOT NULL) PR, PRODUTO P
          WHERE IDENTRSAIDOP = P_IDENTRSAIDOP
            AND CDTIPOOPER = P_CDTIPOOPER
            AND C.CDPRODUTO = P.CDPRODUTO
            AND P.CDARVPROD = PR.CDARVPROD;
      EXCEPTION
         WHEN NO_DATA_FOUND THEN
            V_CDCONTPRODIPI := NULL;
      END;
      /* CASO NO EXISTA CONTA CONTBIL DO PRODUTO POR TIPO DE OPERAO,  VERIFICADO SE EXISTE
         CONTA CONTBIL PARA O PRODUTO NO TIPO DE OPERAO.
         TABELA: TIPOOPERAC
         CAMPO:  CDCONTPROD */
      IF V_CDCONTPRODIPI IS NULL THEN
         BEGIN
            SELECT CDCONTPROD
              INTO V_CDCONTPRODIPI
              FROM TIPOOPERAC T
             WHERE CDTIPOOPER   = P_CDTIPOOPER
               AND IDENTRSAIDOP = P_IDENTRSAIDOP;
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
               V_CDCONTPRODIPI := NULL;
         END;
      END IF;
      /* CASO NO EXISTA NA PRODUTO POR TIPO DE OPERAO, NEM POR TIPO TIPO DE OPERAO, 
         VERIFICADO SE EXISTE UMA CONTA CONTBIL DO PRODUTO POR FILIAL DE EMISO DA NOTA
         TABELA: PRODFILI
         CAMPO: CDCTBLENTRPF */
      IF V_CDCONTPRODIPI IS NULL THEN
         BEGIN
            SELECT MAX(CDCTBLENTRPF) AS CDCTBLENTRPF
              INTO V_CDCONTPRODIPI
              FROM PRODFILI PF, PRODUTO P
             WHERE CDFILIAL = P_CDFILIEMIT
               AND PF.CDPRODUTO  = V_CDARVPROD
               AND (P.CDPRODUTO IN (SELECT MAX(CDPRODUTO)
                                       FROM PRODUTO C
                                      WHERE (INSTR(PF.CDPRODUTO,RTRIM(C.CDPRODUTO)) = 1)
                                        AND NOT CDCTBLENTRPF IS NULL)
                    OR PF.CDPRODUTO = P.CDPRODUTO);
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
               V_CDCONTPRODIPI := NULL;
         END;
      END IF;
      /* CASO NO EXISTA CONTA CONTBIL DO PRODUTO POR TIPO DE OPERAO, DO TIPO DE OPERAO,
         PRODUTO PROUTO POR FILIAL,  BUSCADO A CONTA CONTBIL DA ABA PRODUTO.
         UTILIZADO A FUNO: CONTCTBL_PRODUTO
         PARMETROS: CDIGO_DO_PRODUTO;
                     ENTRADA/SAIDA;
                     FILIAL */
      IF V_CDCONTPRODIPI IS NULL THEN
         SELECT CONTCTBL_PRODUTO(P_CDPRODUTO, P_CDFILIEMIT, P_IDENTRSAIDOP)
           INTO V_CDCONTPRODIPI
           FROM DUAL;
      END IF;
      RETURN V_CDCONTPRODIPI;
   END;

   PROCEDURE DESPESA_DIFALIQUOTA(P_CDEMPRESA IN EMPRESA.CDEMPRESA%TYPE,
                                 P_CDFILIAL IN FILIAL.CDFILIAL%TYPE,
                                 P_CDFILIRECE IN FILIAL.CDFILIAL%TYPE,
                                 P_NRLANCTONF IN NOTAFISCAL.NRLANCTONF%TYPE,
                                 P_NRNOTAFISC IN NOTAFISCAL.NRNOTAFISC%TYPE,
                                 P_IDENTRSAID IN NOTAFISCAL.IDENTRSAIDOP%TYPE,
                                 P_IDORIGDESTNF IN NOTAFISCAL.IDORIGDESTNF%TYPE,
                                 P_CDFORNECED IN NOTAFISCAL.CDFORNECED%TYPE,
                                 P_CDCLIENTE IN NOTAFISCAL.CDCLIENTE%TYPE,
                                 P_DTENTRSAID IN NOTAFISCAL.DTENTRSAID%TYPE)
   AS
   BEGIN
      NUMEROPARTIDA(P_CDEMPRESA, P_IDORIGDESTNF, P_CDFORNECED, P_CDCLIENTE);
      V_CDCENTCUST := BUSCA_CCUSTO(P_CDFILIRECE, P_CDEMPRESA);
      FOR C_DESPDIFALIQ IN
         (SELECT (ROUND(IMP.VRIMPOSTOIT, 2) * -1) VRIMPOSTOIT,
                 CONTCTBL_IMPOSTO(I.CDIMPOSTO, 'D', NF.IDENTRSAIDOP, NF.CDTIPOOPER, NF.IDTPIJURNF) CDCCTBLDESP
            FROM NOTAFISCAL NF, ITEMPROIMPOS IMP, ITEMPRODUTO IT, IMPOSTO I
           WHERE IMP.CDFILIAL    = P_CDFILIAL      AND
                 IMP.NRLANCTONF  = P_NRLANCTONF    AND
                 IMP.CDFILIAL    = NF.CDFILIAL    AND
                 IMP.NRLANCTONF  = NF.NRLANCTONF  AND
                 IMP.NRSEQITPROD = IT.NRSEQITPROD AND
                 IMP.NRLANCTONF  = IT.NRLANCTONF  AND
                 IMP.CDFILIAL    = IT.CDFILIAL    AND
                 IMP.CDIMPOSTO   = I.CDIMPOSTO    AND
                 IMP.CDFISCALIT  IN ('2', '3')    AND
                 IMP.NRITPROIMPOS = '3'           AND
                 I.IDTIPCONTAB   = 'D'            AND
                 IDIMPORECUP     = 'S'            AND
                 IDDIFALIQCUSPRI = 'N') LOOP
         BUSCA_TPCOMERCIAL(C_DESPDIFALIQ.CDCCTBLDESP, V_IDCOME, V_IDCCUS);

          BEGIN
             SELECT COUNT(*), NRSEQCTBTEMP
               INTO V_COUNT, V_NRSEQLANC
               FROM LANCCTBTEMP
              WHERE NRLANCCTBTEMP = P_NRLANCTBTEMP
                AND CDEMPRESA = P_CDEMPRESA
                AND CDCONTCTBL = C_DESPDIFALIQ.CDCCTBLDESP
               GROUP BY NRSEQCTBTEMP;
          EXCEPTION
             WHEN NO_DATA_FOUND THEN
                V_COUNT := 0;
                V_NRSEQLANC := NULL;
          END;

          IF V_COUNT = 0 THEN
             V_NUMPARTIDA := V_NUMPARTIDA + 1;
             INSERT INTO LANCCTBTEMP
                (CDEMPRESA, NRLANCCTBTEMP, CDDOCUTEMP, NRSEQCTBTEMP,
                 CDCONTCTBL, CDHISTPADR,    DSHISTCTB, DTLANCCTBTEMP,
                 VRLANCCTBTEMP, IDLANCCTBCOME, CDLANCCTBCOME, IDSISTEMA)
             VALUES
                (P_CDEMPRESA, P_NRLANCTBTEMP, P_NRNOTAFISC, LPAD(TO_CHAR(V_NUMPARTIDA),5,'0'),
                 C_DESPDIFALIQ.CDCCTBLDESP, V_CDHISTPADR, V_DSHISTLANC, P_DTENTRSAID, C_DESPDIFALIQ.VRIMPOSTOIT, V_IDCOME, V_CDCOMERCIAL, 'DFS');
             IF V_CONTCCUS <> 'N' THEN
                IF V_IDCCUS <> 'O' THEN
                   INSERT INTO RATECTBTEMP
                      (CDEMPRESA, NRLANCCTBTEMP, NRSEQCTBTEMP, CDFILIAL,
                       CDCENTCUST, VRRATECTBTEMP, DTCOMPCTBTEMP, NRSEQRATTEMP)
                   VALUES
                      (P_CDEMPRESA, P_NRLANCTBTEMP, LPAD(TO_CHAR(V_NUMPARTIDA),5,'0'), P_CDFILIRECE,
                       V_CDCENTCUST, C_DESPDIFALIQ.VRIMPOSTOIT, P_DTENTRSAID, '00001');
                END IF;
             END IF;
          ELSE
             UPDATE LANCCTBTEMP
                SET VRLANCCTBTEMP = VRLANCCTBTEMP + C_DESPDIFALIQ.VRIMPOSTOIT
              WHERE CDEMPRESA = P_CDEMPRESA
                AND NRLANCCTBTEMP = P_NRLANCTBTEMP
                AND CDCONTCTBL = C_DESPDIFALIQ.CDCCTBLDESP;

             BEGIN
                SELECT COUNT(*), L.NRSEQCTBTEMP
                  INTO V_COUNT, V_NRSEQLANC
                  FROM LANCCTBTEMP L, RATECTBTEMP R
                 WHERE L.NRLANCCTBTEMP = P_NRLANCTBTEMP
                   AND L.CDEMPRESA = P_CDEMPRESA
                   AND L.CDCONTCTBL = C_DESPDIFALIQ.CDCCTBLDESP
                   AND L.NRLANCCTBTEMP = R.NRLANCCTBTEMP
                   AND L.NRSEQCTBTEMP = R.NRSEQCTBTEMP
                   AND L.CDEMPRESA = R.CDEMPRESA
                   AND R.CDFILIAL = P_CDFILIRECE
                   AND R.CDCENTCUST = V_CDCENTCUST;
             EXCEPTION
                WHEN NO_DATA_FOUND THEN
                    V_COUNT := 0;
                    V_NRSEQLANC := NULL;
             END;

             IF V_COUNT = 0 THEN
                INSERT INTO RATECTBTEMP
                   (CDEMPRESA, NRLANCCTBTEMP, NRSEQCTBTEMP, CDFILIAL,
                    CDCENTCUST, VRRATECTBTEMP, DTCOMPCTBTEMP, NRSEQRATTEMP)
                VALUES
                   (P_CDEMPRESA, P_NRLANCTBTEMP, LPAD(TO_CHAR(V_NUMPARTIDA),5,'0'), P_CDFILIRECE,
                    V_CDCENTCUST, C_DESPDIFALIQ.VRIMPOSTOIT, P_DTENTRSAID, '00001');
             ELSE
                UPDATE RATECTBTEMP
                   SET VRRATECTBTEMP = VRRATECTBTEMP + C_DESPDIFALIQ.VRIMPOSTOIT
                 WHERE CDEMPRESA = P_CDEMPRESA
                   AND NRLANCCTBTEMP = P_NRLANCTBTEMP
                   AND NRSEQCTBTEMP = V_NRSEQLANC
                   AND CDFILIAL = P_CDFILIRECE
                   AND CDCENTCUST = V_CDCENTCUST;
             END IF;
          END IF;
      END LOOP;
   END;
BEGIN
   /* BUSCA O HISTORICO PARA O LANCAMENTO */
   CTB_DFE_HISTORICO(P_CDFILIAL, P_NRLANCTONF, V_CDHISTPADR, V_DSHISTLANC);
   FOR C_NOTAFISCAL IN
      (SELECT NF.CDFILIAL,      NF.NRLANCTONF,    NF.CDEMPRESA,
              NF.IDDOCFINANC,   NF.NRNOTAFISC,    NF.CDCLIENTE,
              NF.CDFORNECED,    NF.NRLANCTBDOC,   NF.VRNOTAFISC,
              NF.CDFILIEMIT,    NF.CDTIPOOPER,    TP.IDCONTABOPER,
              TP.IDOPERDEVONF,  NF.IDORIGDESTNF,  NF.VRPRODUTOS,
              NF.CDFILIRECE,    NF.DTENTRSAID,    NF.CDINSCESTA,
              NF.DTEMISSAO,     C.IDPRIPUBCLIE,   NF.IDENTRSAIDOP,
              NVL(FI.CDCENTCUST, EP.CDCENTCUST) AS CDCENTCUST,
              TP.CDTPCTPAGAR AS CDTPCTPAGOP, TP.CDTPCTRECEB AS CDTPCTRECOP,
              TC.CDCLASSFINA AS CDCLAFINOP, FO.DTINIVRPDESC, NF.CDSERIEENTR,
              NF.CDSERIE, NF.IDTPIJURNF, NF.NRINSJURNF, TP.IDDTCONTAB,
              TP.IDCOAVRIMPVRPROD, TP.IDCONTSOMENIMPO, TP.IDCONTCONFORIG,
              TP.IDDESCIMPRECCOFI
         FROM NOTAFISCAL NF, FILIAL FI, EMPRESA EP,
              TIPOOPERAC TP, TIPOCTPAGAR TC, FORNECEDOR FO, CLIENTE C
        WHERE NF.CDFILIAL     = P_CDFILIAL        AND
              NF.NRLANCTONF   = P_NRLANCTONF      AND
              NF.CDEMPRESA    = EP.CDEMPRESA      AND
              NF.IDENTRSAIDOP = TP.IDENTRSAIDOP   AND
              NF.CDTIPOOPER   = TP.CDTIPOOPER     AND
              TP.CDTPCTPAGAR  = TC.CDTPCTPAGAR(+) AND
              DECODE(NF.IDENTRSAIDOP,'E', NF.CDFILIRECE, NF.CDFILIEMIT) = FI.CDFILIAL AND
              NF.CDFORNECED   = FO.CDFORNECED(+)  AND
              NF.CDCLIENTE    = C.CDCLIENTE(+))LOOP
      IF P_IDDEVOLUCAO = 'S' THEN
         DESPESA_DIFALIQUOTA(C_NOTAFISCAL.CDEMPRESA, C_NOTAFISCAL.CDFILIAL, C_NOTAFISCAL.CDFILIEMIT, C_NOTAFISCAL.NRLANCTONF,
                             C_NOTAFISCAL.NRNOTAFISC, C_NOTAFISCAL.IDENTRSAIDOP, C_NOTAFISCAL.IDORIGDESTNF,
                             C_NOTAFISCAL.CDFORNECED, C_NOTAFISCAL.CDCLIENTE, C_NOTAFISCAL.DTEMISSAO);
         FOR C_IMPOSTO IN
            (SELECT IMP.CDIMPOSTO, I.IDTRATIMPO,  I.IDIMPORECUP, IMP.IDTRIMPSTII IDTRIMPOSTNF, I.IDACRPRODENTRNF,
                    ROUND(SUM(IMP.VRIMPOSTOIT),    2) AS VRIMPOSTONF,
                    0 AS VRIMPCARGATRIBI,
                    CDCONTATIV,
                    CDCONTPASS,
                    CDCONTDESP, IMP.CDFISCALIT CDFISCALNF, I.CDCCTBLATIV CDCONTATIVO
               FROM ITEMPROIMPOSORIG IMP, NOTAFISCAL NF, IMPOSTO I, PARAMFILIAL PF,
                    (SELECT DISTINCT CDIMPOSTO,
                                     CONTCTBL_IMPOSTO(I.CDIMPOSTO, 'A', 'S', NF.CDTIPOOPER, NF.IDTPIJURNF) AS CDCONTATIV,
                                     CONTCTBL_IMPOSTO(I.CDIMPOSTO, 'P', 'S', NF.CDTIPOOPER, NF.IDTPIJURNF) AS CDCONTPASS,
                                     CONTCTBL_IMPOSTO(I.CDIMPOSTO, 'D', 'S', NF.CDTIPOOPER, NF.IDTPIJURNF) AS CDCONTDESP
                       FROM ITEMPROIMPOSORIG I, NOTAFISCAL NF
                      WHERE I.CDFILIAL   = NF.CDFILIAL
                        AND I.NRLANCTONF = NF.NRLANCTONF
                        AND I.CDFILIAL   = P_CDFILIAL
                        AND I.NRLANCTONF = P_NRLANCTONF) CT
              WHERE IMP.VRIMPOSTOIT > 0
                AND IMP.CDIMPOSTO = CT.CDIMPOSTO
                AND IMP.CDIMPOSTO = I.CDIMPOSTO
                AND ((IMP.NRITPROIMPOS IN ('1','4')) OR (IMP.NRITPROIMPOS IS NULL))
                AND I.IDTIPCONTAB  = 'D'
                AND ((((I.IDIMPORECUP  = 'S'  AND IMP.CDFISCALIT = '1' AND PF.IDCARACFIS  = 'C') OR (PF.IDCARACFIS = 'A')) AND (CT.CDCONTATIV IS NOT NULL))
                    OR
                    ((I.IDIMPORECUP <> 'S') AND (CT.CDCONTPASS IS NOT NULL)))
                AND NF.CDFILIAL     = P_CDFILIAL
                AND NF.NRLANCTONF   = P_NRLANCTONF
                AND NF.CDFILIEMIT   = PF.CDFILIAL
                AND NF.CDFILIAL     = IMP.CDFILIAL
                AND NF.NRLANCTONF   = IMP.NRLANCTONF
                AND EXISTS (SELECT 1
                              FROM (SELECT  A.CDIMPOSTO, A.CDFILIAL, A.NRLANCTONF, A.CDFISCALNF
                                      FROM (SELECT INF.CDIMPOSTO, VRIMPOSTONF, NVL(IDACRPRODENTRNF, 'N') IDACRPRODENTRNF,
                                                   PF.IDCARACFIS, I.IDIMPORECUP, I.IDTRATIMPO, INF.CDFISCALNF,
                                                   CONTCTBL_IMPOSTO(I.CDIMPOSTO, 'A', NF.IDENTRSAIDOP, NF.CDTIPOOPER, NF.IDTPIJURNF) CDCONTATIV,
                                                   CONTCTBL_IMPOSTO(I.CDIMPOSTO, 'P', NF.IDENTRSAIDOP, NF.CDTIPOOPER, NF.IDTPIJURNF) CDCONTPASS,
                                                   CONTCTBL_IMPOSTO(I.CDIMPOSTO, 'D', NF.IDENTRSAIDOP, NF.CDTIPOOPER, NF.IDTPIJURNF) CDCONTDESP,
                                                   CONTCTBL_IMPOSTO(I.CDIMPOSTO, 'E', NF.IDENTRSAIDOP, NF.CDTIPOOPER, NF.IDTPIJURNF) CDCONTIMPO,
                                                   NF.NRLANCTONF, NF.CDFILIAL
                                              FROM IMPOSTONF INF, IMPOSTO I, NOTAFISCAL NF, PARAMFILIAL PF, ITEMNOTAFISC IT
                                             WHERE NF.CDFILIAL     = IT.CDFILIALIT
                                               AND NF.NRLANCTONF   = IT.NRLANCTONFIT
                                               AND PF.CDFILIAL(+)  = NF.CDFILIRECE
                                               AND INF.CDFILIAL    = IT.CDFILIALIT
                                               AND INF.NRLANCTONF  = IT.NRLANCTONFIT
                                               AND IT.CDFILIAL = P_CDFILIAL
                                               AND IT.NRLANCTONF = P_NRLANCTONF
                                               AND INF.CDIMPOSTO   = I.CDIMPOSTO
                                               AND I.IDTIPCONTAB  = 'D') A
                                     WHERE ((((A.IDIMPORECUP  = 'S' AND A.CDFISCALNF = '1' AND NVL(A.IDCARACFIS,'C') = 'C') OR (A.IDCARACFIS = 'A')) AND (A.CDCONTATIV IS NOT NULL)) OR
                                            ((A.IDIMPORECUP <> 'S') AND (A.CDCONTPASS IS NOT NULL)))) IMPORIGEM
                            WHERE IMP.CDIMPOSTO = IMPORIGEM.CDIMPOSTO
                              AND IMP.CDFISCALIT = IMPORIGEM.CDFISCALNF)
              GROUP BY IMP.CDIMPOSTO, I.IDTRATIMPO,  I.IDIMPORECUP, IMP.IDTRIMPSTII, I.IDACRPRODENTRNF,
                       CDCONTPASS, CDCONTATIV, CDCONTDESP, IMP.CDFISCALIT, I.CDCCTBLATIV) LOOP
            IF C_IMPOSTO.VRIMPOSTONF > 0 THEN
               BEGIN
                  SELECT CDIMPOSTO
                    INTO V_IMPOSCARGATRIB
                    FROM IMPOSTO
                   WHERE CDIMPCARGATRIB = C_IMPOSTO.CDIMPOSTO;
               EXCEPTION
                  WHEN NO_DATA_FOUND THEN
                     V_IMPOSCARGATRIB := NULL;
               END;

               V_CONTAATIV := C_IMPOSTO.CDCONTATIV;
               V_CONTAATIV := CTB_CCTBL_IMPFIL(C_NOTAFISCAL.CDFILIEMIT, C_NOTAFISCAL.IDENTRSAIDOP, C_NOTAFISCAL.CDTIPOOPER, C_IMPOSTO.CDIMPOSTO, V_CONTAATIV, 'A');

               V_CONTAPASS := C_IMPOSTO.CDCONTPASS;
               V_CONTAPASS := CTB_CCTBL_IMPFIL(C_NOTAFISCAL.CDFILIEMIT, C_NOTAFISCAL.IDENTRSAIDOP, C_NOTAFISCAL.CDTIPOOPER, C_IMPOSTO.CDIMPOSTO, V_CONTAPASS, 'P');

               V_CONTADESP := C_IMPOSTO.CDCONTDESP;
               V_CONTADESP := CTB_CCTBL_IMPFIL(C_NOTAFISCAL.CDFILIEMIT, C_NOTAFISCAL.IDENTRSAIDOP, C_NOTAFISCAL.CDTIPOOPER, C_IMPOSTO.CDIMPOSTO, V_CONTADESP, 'D');

               IF C_NOTAFISCAL.IDOPERDEVONF <> 'S' THEN
                  BEGIN
                     SELECT MAX(CDIMPOSTO) AS CDIMPOSTRIB
                       INTO V_CDIMPOSUBST
                       FROM IMPOSTO
                      WHERE CDIMPOSTRIB = C_IMPOSTO.CDIMPOSTO;
                  EXCEPTION
                     WHEN NO_DATA_FOUND THEN
                        V_CDIMPOSUBST := NULL;
                  END;
                  IF V_CDIMPOSUBST IS NOT NULL THEN /* SUBSTITUIO TRIBUTRIA */
                     NUMEROPARTIDA(C_NOTAFISCAL.CDEMPRESA, C_NOTAFISCAL.IDORIGDESTNF, C_NOTAFISCAL.CDFORNECED, C_NOTAFISCAL.CDCLIENTE);
                     PARTIDA(C_NOTAFISCAL.CDEMPRESA, C_NOTAFISCAL.CDFILIAL, C_NOTAFISCAL.CDFILIRECE, C_NOTAFISCAL.CDFILIEMIT, C_NOTAFISCAL.NRLANCTONF,
                             C_NOTAFISCAL.NRNOTAFISC, C_NOTAFISCAL.IDENTRSAIDOP, C_NOTAFISCAL.IDORIGDESTNF,
                             C_NOTAFISCAL.CDFORNECED, C_NOTAFISCAL.CDCLIENTE, C_NOTAFISCAL.DTEMISSAO, 1, V_CONTAPASS, 'S', C_IMPOSTO.VRIMPOSTONF);
                     NUMEROPARTIDA(C_NOTAFISCAL.CDEMPRESA, C_NOTAFISCAL.IDORIGDESTNF, C_NOTAFISCAL.CDFORNECED, C_NOTAFISCAL.CDCLIENTE);
                     PARTIDA(C_NOTAFISCAL.CDEMPRESA, C_NOTAFISCAL.CDFILIAL, C_NOTAFISCAL.CDFILIRECE, C_NOTAFISCAL.CDFILIEMIT, C_NOTAFISCAL.NRLANCTONF,
                             C_NOTAFISCAL.NRNOTAFISC, C_NOTAFISCAL.IDENTRSAIDOP, C_NOTAFISCAL.IDORIGDESTNF,
                             C_NOTAFISCAL.CDFORNECED, C_NOTAFISCAL.CDCLIENTE, C_NOTAFISCAL.DTEMISSAO, -1, V_CONTADESP, 'S', C_IMPOSTO.VRIMPOSTONF);
                  ELSE
                     IF C_IMPOSTO.IDTRIMPOSTNF IS NOT NULL THEN
                        IF C_IMPOSTO.IDTRIMPOSTNF = '0' THEN
                           NUMEROPARTIDA(C_NOTAFISCAL.CDEMPRESA, C_NOTAFISCAL.IDORIGDESTNF, C_NOTAFISCAL.CDFORNECED, C_NOTAFISCAL.CDCLIENTE);
                           PARTIDA(C_NOTAFISCAL.CDEMPRESA, C_NOTAFISCAL.CDFILIAL, C_NOTAFISCAL.CDFILIRECE, C_NOTAFISCAL.CDFILIEMIT, C_NOTAFISCAL.NRLANCTONF,
                                   C_NOTAFISCAL.NRNOTAFISC, C_NOTAFISCAL.IDENTRSAIDOP, C_NOTAFISCAL.IDORIGDESTNF,
                                   C_NOTAFISCAL.CDFORNECED, C_NOTAFISCAL.CDCLIENTE, C_NOTAFISCAL.DTEMISSAO, 1, V_CONTAPASS, 'S', C_IMPOSTO.VRIMPOSTONF);
                        ELSE
                           NUMEROPARTIDA(C_NOTAFISCAL.CDEMPRESA, C_NOTAFISCAL.IDORIGDESTNF, C_NOTAFISCAL.CDFORNECED, C_NOTAFISCAL.CDCLIENTE);
                           PARTIDA(C_NOTAFISCAL.CDEMPRESA, C_NOTAFISCAL.CDFILIAL, C_NOTAFISCAL.CDFILIRECE, C_NOTAFISCAL.CDFILIEMIT, C_NOTAFISCAL.NRLANCTONF,
                                   C_NOTAFISCAL.NRNOTAFISC, C_NOTAFISCAL.IDENTRSAIDOP, C_NOTAFISCAL.IDORIGDESTNF,
                                   C_NOTAFISCAL.CDFORNECED, C_NOTAFISCAL.CDCLIENTE, C_NOTAFISCAL.DTEMISSAO, 1, V_CONTAPASS, 'S', C_IMPOSTO.VRIMPOSTONF);
                           NUMEROPARTIDA(C_NOTAFISCAL.CDEMPRESA, C_NOTAFISCAL.IDORIGDESTNF, C_NOTAFISCAL.CDFORNECED, C_NOTAFISCAL.CDCLIENTE);
                           PARTIDA(C_NOTAFISCAL.CDEMPRESA, C_NOTAFISCAL.CDFILIAL, C_NOTAFISCAL.CDFILIRECE, C_NOTAFISCAL.CDFILIEMIT, C_NOTAFISCAL.NRLANCTONF,
                                   C_NOTAFISCAL.NRNOTAFISC, C_NOTAFISCAL.IDENTRSAIDOP, C_NOTAFISCAL.IDORIGDESTNF,
                                   C_NOTAFISCAL.CDFORNECED, C_NOTAFISCAL.CDCLIENTE, C_NOTAFISCAL.DTEMISSAO, -1, V_CONTADESP, 'S', C_IMPOSTO.VRIMPOSTONF);
                        END IF;
                     ELSE
                        IF C_IMPOSTO.IDTRATIMPO = 'R' THEN
                           NUMEROPARTIDA(C_NOTAFISCAL.CDEMPRESA, C_NOTAFISCAL.IDORIGDESTNF, C_NOTAFISCAL.CDFORNECED, C_NOTAFISCAL.CDCLIENTE);
                           PARTIDA(C_NOTAFISCAL.CDEMPRESA, C_NOTAFISCAL.CDFILIAL, C_NOTAFISCAL.CDFILIRECE, C_NOTAFISCAL.CDFILIEMIT, C_NOTAFISCAL.NRLANCTONF,
                                   C_NOTAFISCAL.NRNOTAFISC, C_NOTAFISCAL.IDENTRSAIDOP, C_NOTAFISCAL.IDORIGDESTNF,
                                   C_NOTAFISCAL.CDFORNECED, C_NOTAFISCAL.CDCLIENTE, C_NOTAFISCAL.DTEMISSAO, -1, V_CONTAATIV, 'S', C_IMPOSTO.VRIMPOSTONF);
                        ELSE
                           IF C_IMPOSTO.IDTRATIMPO = 'A' THEN
                              NUMEROPARTIDA(C_NOTAFISCAL.CDEMPRESA, C_NOTAFISCAL.IDORIGDESTNF, C_NOTAFISCAL.CDFORNECED, C_NOTAFISCAL.CDCLIENTE);
                              PARTIDA(C_NOTAFISCAL.CDEMPRESA, C_NOTAFISCAL.CDFILIAL, C_NOTAFISCAL.CDFILIRECE, C_NOTAFISCAL.CDFILIEMIT, C_NOTAFISCAL.NRLANCTONF,
                                   C_NOTAFISCAL.NRNOTAFISC, C_NOTAFISCAL.IDENTRSAIDOP, C_NOTAFISCAL.IDORIGDESTNF,
                                   C_NOTAFISCAL.CDFORNECED, C_NOTAFISCAL.CDCLIENTE, C_NOTAFISCAL.DTEMISSAO, 1, V_CONTAPASS, 'S', C_IMPOSTO.VRIMPOSTONF);
                              /* Verifica se o imposto  recupervel
                                 para contabilizar uma partida na Receita e outra na Despesa. */
                              FOR C_ITEMPROIMPOSIPI IN
                                 (SELECT ROUND(VRIMPOSTOIT, 2) VRIMPOSTOIT, IT.CDPRODUTO, CONTCTBL_PRODUTO(IT.CDPRODUTO, 'S', NF.CDFILIEMIT) AS CDCTBLSAIDPR,
                                          CONTCTBL_PRODUTO(IT.CDPRODUTO, 'E', NF.CDFILIEMIT) CDCTBLENTRPR
                                    FROM ITEMPROIMPOS IMP, (SELECT DISTINCT CDIMPOSTO,
                                                                            CONTCTBL_IMPOSTO(I.CDIMPOSTO, 'A', C_NOTAFISCAL.IDENTRSAIDOP, NF.CDTIPOOPER, NF.IDTPIJURNF) AS CDCONTATIV,
                                                                            CONTCTBL_IMPOSTO(I.CDIMPOSTO, 'P', C_NOTAFISCAL.IDENTRSAIDOP, NF.CDTIPOOPER, NF.IDTPIJURNF) AS CDCONTPASS,
                                                                            CONTCTBL_IMPOSTO(I.CDIMPOSTO, 'D', C_NOTAFISCAL.IDENTRSAIDOP, NF.CDTIPOOPER, NF.IDTPIJURNF) AS CDCONTDESP
                                                              FROM ITEMPROIMPOS I, NOTAFISCAL NF
                                                             WHERE I.CDFILIAL   = NF.CDFILIAL
                                                               AND I.NRLANCTONF = NF.NRLANCTONF
                                                               AND I.CDFILIAL   = P_CDFILIAL
                                                               AND I.NRLANCTONF = P_NRLANCTONF) CT, IMPOSTO I, PARAMFILIAL PF, NOTAFISCAL NF, ITEMPRODUTO IT
                                   WHERE IMP.NRLANCTONF = P_NRLANCTONF
                                     AND IMP.CDFILIAL = P_CDFILIAL
                                     AND IMP.VRIMPOSTOIT > 0
                                     AND IMP.CDIMPOSTO = CT.CDIMPOSTO
                                     AND IMP.CDIMPOSTO = I.CDIMPOSTO
                                     AND ((IMP.NRITPROIMPOS IN ('1','4')) OR (IMP.NRITPROIMPOS IS NULL))
                                     AND I.IDTIPCONTAB  = 'D'
                                     AND CT.CDCONTPASS IS NOT NULL
                                     AND IMP.CDFILIAL = NF.CDFILIAL
                                     AND IMP.NRLANCTONF = NF.NRLANCTONF
                                     AND IMP.CDFILIAL = IT.CDFILIAL
                                     AND IMP.NRLANCTONF = IT.NRLANCTONF
                                     AND I.CDIMPOSTO = C_IMPOSTO.CDIMPOSTO
                                     AND DECODE(NF.IDENTRSAIDOP, 'E', NF.CDFILIRECE, NF.CDFILIEMIT) = PF.CDFILIAL
                                     AND IT.NRSEQITPROD = IMP.NRSEQITPROD
                                     AND I.IDTRATIMPO = 'A'
                                     AND I.IDIMPORECUP = 'S') LOOP

                                 /* VERIFICA SE O PARAMETRO "CONTABILIZA SOMENTE IMPOSTOS NO TIPO DE OPERAO EST MARCADO.
                                    CASO ESTEJA MARCADO, O IPI OU OUTRO IMPOSTO RECUPERAVEL A ACRESCER, OS VALORES DOS IMPOSTOS
                                    NO DEVEM COMPOR O VALOR DO PRODUTO. */
                                 IF C_NOTAFISCAL.IDCONTSOMENIMPO = 'N' THEN
                                    V_CDCONTPROD := CONTAPRODUTOIPI(C_ITEMPROIMPOSIPI.CDPRODUTO, 'S', C_NOTAFISCAL.CDTIPOOPER, C_NOTAFISCAL.CDFILIEMIT);

                                    NUMEROPARTIDA(C_NOTAFISCAL.CDEMPRESA, C_NOTAFISCAL.IDORIGDESTNF, C_NOTAFISCAL.CDFORNECED, C_NOTAFISCAL.CDCLIENTE);
                                    PARTIDA(C_NOTAFISCAL.CDEMPRESA, C_NOTAFISCAL.CDFILIAL, C_NOTAFISCAL.CDFILIRECE, C_NOTAFISCAL.CDFILIEMIT, C_NOTAFISCAL.NRLANCTONF,
                                            C_NOTAFISCAL.NRNOTAFISC, C_NOTAFISCAL.IDENTRSAIDOP, C_NOTAFISCAL.IDORIGDESTNF,
                                            C_NOTAFISCAL.CDFORNECED, C_NOTAFISCAL.CDCLIENTE, C_NOTAFISCAL.DTEMISSAO, 1, V_CDCONTPROD, 'S', C_ITEMPROIMPOSIPI.VRIMPOSTOIT);

                                 END IF;
                                 NUMEROPARTIDA(C_NOTAFISCAL.CDEMPRESA, C_NOTAFISCAL.IDORIGDESTNF, C_NOTAFISCAL.CDFORNECED, C_NOTAFISCAL.CDCLIENTE);
                                 PARTIDA(C_NOTAFISCAL.CDEMPRESA, C_NOTAFISCAL.CDFILIAL, C_NOTAFISCAL.CDFILIRECE, C_NOTAFISCAL.CDFILIEMIT, C_NOTAFISCAL.NRLANCTONF,
                                         C_NOTAFISCAL.NRNOTAFISC, C_NOTAFISCAL.IDENTRSAIDOP, C_NOTAFISCAL.IDORIGDESTNF,
                                         C_NOTAFISCAL.CDFORNECED, C_NOTAFISCAL.CDCLIENTE, C_NOTAFISCAL.DTEMISSAO, -1, V_CONTADESP, 'S', C_ITEMPROIMPOSIPI.VRIMPOSTOIT);

                              END LOOP;
                           ELSE
                              IF C_IMPOSTO.IDTRATIMPO = 'D' THEN
                                 NUMEROPARTIDA(C_NOTAFISCAL.CDEMPRESA, C_NOTAFISCAL.IDORIGDESTNF, C_NOTAFISCAL.CDFORNECED, C_NOTAFISCAL.CDCLIENTE);
                                 PARTIDA(C_NOTAFISCAL.CDEMPRESA, C_NOTAFISCAL.CDFILIAL, C_NOTAFISCAL.CDFILIRECE, C_NOTAFISCAL.CDFILIEMIT, C_NOTAFISCAL.NRLANCTONF,
                                         C_NOTAFISCAL.NRNOTAFISC, C_NOTAFISCAL.IDENTRSAIDOP, C_NOTAFISCAL.IDORIGDESTNF,
                                         C_NOTAFISCAL.CDFORNECED, C_NOTAFISCAL.CDCLIENTE, C_NOTAFISCAL.DTEMISSAO, -1, V_CONTAATIV, 'S', C_IMPOSTO.VRIMPOSTONF);
                              ELSE
                                 IF ((C_NOTAFISCAL.IDORIGDESTNF = 'L') AND (C_NOTAFISCAL.IDDESCIMPRECCOFI = 'N')) THEN
                                    NUMEROPARTIDA(C_NOTAFISCAL.CDEMPRESA, C_NOTAFISCAL.IDORIGDESTNF, C_NOTAFISCAL.CDFORNECED, C_NOTAFISCAL.CDCLIENTE);
                                    PARTIDA(C_NOTAFISCAL.CDEMPRESA, C_NOTAFISCAL.CDFILIAL, C_NOTAFISCAL.CDFILIRECE, C_NOTAFISCAL.CDFILIEMIT, C_NOTAFISCAL.NRLANCTONF,
                                            C_NOTAFISCAL.NRNOTAFISC, C_NOTAFISCAL.IDENTRSAIDOP, C_NOTAFISCAL.IDORIGDESTNF,
                                            C_NOTAFISCAL.CDFORNECED, C_NOTAFISCAL.CDCLIENTE, C_NOTAFISCAL.DTEMISSAO, 1, V_CONTAPASS, 'S', C_IMPOSTO.VRIMPOSTONF);
                                 ELSE
                                    IF C_IMPOSTO.VRIMPCARGATRIBI > 0 THEN
                                       NUMEROPARTIDA(C_NOTAFISCAL.CDEMPRESA, C_NOTAFISCAL.IDORIGDESTNF, C_NOTAFISCAL.CDFORNECED, C_NOTAFISCAL.CDCLIENTE);
                                       PARTIDA(C_NOTAFISCAL.CDEMPRESA, C_NOTAFISCAL.CDFILIAL, C_NOTAFISCAL.CDFILIRECE, C_NOTAFISCAL.CDFILIEMIT, C_NOTAFISCAL.NRLANCTONF,
                                               C_NOTAFISCAL.NRNOTAFISC, C_NOTAFISCAL.IDENTRSAIDOP, C_NOTAFISCAL.IDORIGDESTNF,
                                               C_NOTAFISCAL.CDFORNECED, C_NOTAFISCAL.CDCLIENTE, C_NOTAFISCAL.DTEMISSAO, 1, V_CONTAPASS, 'S', C_IMPOSTO.VRIMPCARGATRIBI);

                                       NUMEROPARTIDA(C_NOTAFISCAL.CDEMPRESA, C_NOTAFISCAL.IDORIGDESTNF, C_NOTAFISCAL.CDFORNECED, C_NOTAFISCAL.CDCLIENTE);
                                       PARTIDA(C_NOTAFISCAL.CDEMPRESA, C_NOTAFISCAL.CDFILIAL, C_NOTAFISCAL.CDFILIRECE, C_NOTAFISCAL.CDFILIEMIT, C_NOTAFISCAL.NRLANCTONF,
                                               C_NOTAFISCAL.NRNOTAFISC, C_NOTAFISCAL.IDENTRSAIDOP, C_NOTAFISCAL.IDORIGDESTNF,
                                               C_NOTAFISCAL.CDFORNECED, C_NOTAFISCAL.CDCLIENTE, C_NOTAFISCAL.DTEMISSAO, -1, V_CONTADESP, 'S', C_IMPOSTO.VRIMPCARGATRIBI);
                                    ELSE
                                       IF V_IMPOSCARGATRIB IS NULL THEN
                                          NUMEROPARTIDA(C_NOTAFISCAL.CDEMPRESA, C_NOTAFISCAL.IDORIGDESTNF, C_NOTAFISCAL.CDFORNECED, C_NOTAFISCAL.CDCLIENTE);
                                          PARTIDA(C_NOTAFISCAL.CDEMPRESA, C_NOTAFISCAL.CDFILIAL, C_NOTAFISCAL.CDFILIRECE, C_NOTAFISCAL.CDFILIEMIT, C_NOTAFISCAL.NRLANCTONF,
                                                  C_NOTAFISCAL.NRNOTAFISC, C_NOTAFISCAL.IDENTRSAIDOP, C_NOTAFISCAL.IDORIGDESTNF,
                                                  C_NOTAFISCAL.CDFORNECED, C_NOTAFISCAL.CDCLIENTE, C_NOTAFISCAL.DTEMISSAO, 1, V_CONTAPASS, 'S', C_IMPOSTO.VRIMPOSTONF);

                                          NUMEROPARTIDA(C_NOTAFISCAL.CDEMPRESA, C_NOTAFISCAL.IDORIGDESTNF, C_NOTAFISCAL.CDFORNECED, C_NOTAFISCAL.CDCLIENTE);
                                          PARTIDA(C_NOTAFISCAL.CDEMPRESA, C_NOTAFISCAL.CDFILIAL, C_NOTAFISCAL.CDFILIRECE, C_NOTAFISCAL.CDFILIEMIT, C_NOTAFISCAL.NRLANCTONF,
                                                  C_NOTAFISCAL.NRNOTAFISC, C_NOTAFISCAL.IDENTRSAIDOP, C_NOTAFISCAL.IDORIGDESTNF,
                                                  C_NOTAFISCAL.CDFORNECED, C_NOTAFISCAL.CDCLIENTE, C_NOTAFISCAL.DTEMISSAO, -1, V_CONTADESP, 'S', C_IMPOSTO.VRIMPOSTONF);
                                       ELSE
                                          BEGIN
                                             SELECT INF.VRIMPCARGATRIBI
                                               INTO V_VRCARGATRIB
                                               FROM IMPOSTONF INF, IMPOSTO I
                                              WHERE INF.CDIMPOSTO  = V_IMPOSCARGATRIB
                                                AND INF.NRLANCTONF = P_NRLANCTONF
                                                AND INF.CDFILIAL   = P_CDFILIAL
                                                AND I.CDIMPOSTO = INF.CDIMPOSTO
                                                AND INF.VRIMPCARGATRIBI > 0;
                                          EXCEPTION
                                             WHEN NO_DATA_FOUND THEN
                                                V_VRCARGATRIB := 0;
                                          END;

                                          V_CONTAPASS := CTB_CCTBL_IMPFIL(C_NOTAFISCAL.CDFILIEMIT, C_NOTAFISCAL.IDENTRSAIDOP, C_NOTAFISCAL.CDTIPOOPER, V_IMPOSCARGATRIB, V_CONTAPASS, 'P');
                                          NUMEROPARTIDA(C_NOTAFISCAL.CDEMPRESA, C_NOTAFISCAL.IDORIGDESTNF, C_NOTAFISCAL.CDFORNECED, C_NOTAFISCAL.CDCLIENTE);
                                          PARTIDA(C_NOTAFISCAL.CDEMPRESA, C_NOTAFISCAL.CDFILIAL, C_NOTAFISCAL.CDFILIRECE, C_NOTAFISCAL.CDFILIEMIT, C_NOTAFISCAL.NRLANCTONF,
                                                  C_NOTAFISCAL.NRNOTAFISC, C_NOTAFISCAL.IDENTRSAIDOP, C_NOTAFISCAL.IDORIGDESTNF,
                                                  C_NOTAFISCAL.CDFORNECED, C_NOTAFISCAL.CDCLIENTE, C_NOTAFISCAL.DTEMISSAO, 1, V_CONTAPASS, 'S', V_VRCARGATRIB);

                                          V_CONTADESP := CTB_CCTBL_IMPFIL(C_NOTAFISCAL.CDFILIEMIT, C_NOTAFISCAL.IDENTRSAIDOP, C_NOTAFISCAL.CDTIPOOPER, V_IMPOSCARGATRIB, V_CONTADESP, 'D');
                                          NUMEROPARTIDA(C_NOTAFISCAL.CDEMPRESA, C_NOTAFISCAL.IDORIGDESTNF, C_NOTAFISCAL.CDFORNECED, C_NOTAFISCAL.CDCLIENTE);
                                          PARTIDA(C_NOTAFISCAL.CDEMPRESA, C_NOTAFISCAL.CDFILIAL, C_NOTAFISCAL.CDFILIRECE, C_NOTAFISCAL.CDFILIEMIT, C_NOTAFISCAL.NRLANCTONF,
                                                  C_NOTAFISCAL.NRNOTAFISC, C_NOTAFISCAL.IDENTRSAIDOP, C_NOTAFISCAL.IDORIGDESTNF,
                                                  C_NOTAFISCAL.CDFORNECED, C_NOTAFISCAL.CDCLIENTE, C_NOTAFISCAL.DTEMISSAO, -1, V_CONTADESP, 'S', V_VRCARGATRIB);
                                       END IF;
                                    END IF;
                                 END IF;
                              END IF;
                           END IF;
                        END IF;
                     END IF;
                  END IF;
               ELSE
                  /* NOTAS FISCAIS DE DEVOLUO PARA FORNECEDOR */
                  /* IR REALIZAR AS CONTABILIZAES SOMENTE PARA OS IMPOSTOS QUE FORAM CONTABILIZADOS
                     NA ENTREDA. */
                  V_COUNT := 0;
                  BEGIN
                     SELECT COUNT(*)
                       INTO V_COUNT
                       FROM (SELECT INF.CDIMPOSTO, VRIMPOSTONF, NVL(IDACRPRODENTRNF, 'N') IDACRPRODENTRNF,
                                    PF.IDCARACFIS, I.IDIMPORECUP, I.IDTRATIMPO, INF.CDFISCALNF,
                                    CONTCTBL_IMPOSTO(I.CDIMPOSTO, 'A', NF.IDENTRSAIDOP, NF.CDTIPOOPER, NF.IDTPIJURNF) CDCONTATIV,
                                    CONTCTBL_IMPOSTO(I.CDIMPOSTO, 'P', NF.IDENTRSAIDOP, NF.CDTIPOOPER, NF.IDTPIJURNF) CDCONTPASS,
                                    CONTCTBL_IMPOSTO(I.CDIMPOSTO, 'D', NF.IDENTRSAIDOP, NF.CDTIPOOPER, NF.IDTPIJURNF) CDCONTDESP,
                                    CONTCTBL_IMPOSTO(I.CDIMPOSTO, 'E', NF.IDENTRSAIDOP, NF.CDTIPOOPER, NF.IDTPIJURNF) CDCONTIMPO,
                                    NF.NRLANCTONF, NF.CDFILIAL
                               FROM IMPOSTONF INF, IMPOSTO I, NOTAFISCAL NF, PARAMFILIAL PF, ITEMNOTAFISC IT
                              WHERE NF.CDFILIAL     = IT.CDFILIALIT
                                AND NF.NRLANCTONF   = IT.NRLANCTONFIT
                                AND PF.CDFILIAL(+)  = NF.CDFILIRECE
                                AND INF.CDFILIAL    = IT.CDFILIALIT
                                AND INF.NRLANCTONF  = IT.NRLANCTONFIT
                                AND IT.CDFILIAL = P_CDFILIAL
                                AND IT.NRLANCTONF = P_NRLANCTONF
                                AND INF.CDIMPOSTO   = I.CDIMPOSTO
                                AND I.CDIMPOSTO = C_IMPOSTO.CDIMPOSTO
                                AND INF.VRIMPOSTONF > 0
                                AND ((IDDIFALIQCUSPRN = 'S' AND INF.IDIMPOSTONF IN ('1','4')) OR (IDDIFALIQCUSPRN = 'N' AND INF.IDIMPOSTONF IN ('1','4')))
                                AND I.IDTIPCONTAB  = 'D') A
                      WHERE ((((A.IDIMPORECUP  = 'S' AND A.CDFISCALNF = '1' AND NVL(A.IDCARACFIS,'C') = 'C') OR (A.IDCARACFIS = 'A')) AND (A.CDCONTATIV IS NOT NULL)) OR
                              ((A.IDIMPORECUP <> 'S') AND (A.CDCONTPASS IS NOT NULL)));
                  EXCEPTION
                     WHEN NO_DATA_FOUND THEN
                        V_COUNT := 0;
                  END;
                  IF ((V_COUNT <> 0) OR (C_NOTAFISCAL.IDOPERDEVONF = 'S' AND
                                         C_NOTAFISCAL.IDCONTCONFORIG = 'N')) THEN
                     BEGIN
                        SELECT MAX(CDIMPOSTO) AS CDIMPOSTRIB
                          INTO V_CDIMPOSUBST
                          FROM IMPOSTO
                         WHERE CDIMPOSTRIB = C_IMPOSTO.CDIMPOSTO;
                     EXCEPTION
                        WHEN NO_DATA_FOUND THEN
                           V_CDIMPOSUBST := NULL;
                     END;

                     IF ((C_IMPOSTO.IDTRATIMPO = 'A') AND (C_IMPOSTO.IDIMPORECUP <> 'S')) THEN
                        NUMEROPARTIDA(C_NOTAFISCAL.CDEMPRESA, C_NOTAFISCAL.IDORIGDESTNF, C_NOTAFISCAL.CDFORNECED, C_NOTAFISCAL.CDCLIENTE);
                        PARTIDA(C_NOTAFISCAL.CDEMPRESA, C_NOTAFISCAL.CDFILIAL, C_NOTAFISCAL.CDFILIRECE, C_NOTAFISCAL.CDFILIEMIT, C_NOTAFISCAL.NRLANCTONF,
                                C_NOTAFISCAL.NRNOTAFISC, C_NOTAFISCAL.IDENTRSAIDOP, C_NOTAFISCAL.IDORIGDESTNF,
                                C_NOTAFISCAL.CDFORNECED, C_NOTAFISCAL.CDCLIENTE, C_NOTAFISCAL.DTEMISSAO, 1, V_CONTADESP, 'S', C_IMPOSTO.VRIMPOSTONF);
                     ELSE
                        IF ((C_IMPOSTO.IDTRATIMPO = 'A') AND (C_IMPOSTO.IDIMPORECUP = 'S')) THEN
                           NUMEROPARTIDA(C_NOTAFISCAL.CDEMPRESA, C_NOTAFISCAL.IDORIGDESTNF, C_NOTAFISCAL.CDFORNECED, C_NOTAFISCAL.CDCLIENTE);
                           PARTIDA(C_NOTAFISCAL.CDEMPRESA, C_NOTAFISCAL.CDFILIAL, C_NOTAFISCAL.CDFILIRECE, C_NOTAFISCAL.CDFILIEMIT, C_NOTAFISCAL.NRLANCTONF,
                                   C_NOTAFISCAL.NRNOTAFISC, C_NOTAFISCAL.IDENTRSAIDOP, C_NOTAFISCAL.IDORIGDESTNF,
                                   C_NOTAFISCAL.CDFORNECED, C_NOTAFISCAL.CDCLIENTE, C_NOTAFISCAL.DTEMISSAO, 1, V_CONTAATIV, 'S', C_IMPOSTO.VRIMPOSTONF);
                        ELSE
                           IF (C_IMPOSTO.IDTRATIMPO = 'R') THEN
                              NUMEROPARTIDA(C_NOTAFISCAL.CDEMPRESA, C_NOTAFISCAL.IDORIGDESTNF, C_NOTAFISCAL.CDFORNECED, C_NOTAFISCAL.CDCLIENTE);
                              PARTIDA(C_NOTAFISCAL.CDEMPRESA, C_NOTAFISCAL.CDFILIAL, C_NOTAFISCAL.CDFILIRECE, C_NOTAFISCAL.CDFILIEMIT, C_NOTAFISCAL.NRLANCTONF,
                                      C_NOTAFISCAL.NRNOTAFISC, C_NOTAFISCAL.IDENTRSAIDOP, C_NOTAFISCAL.IDORIGDESTNF,
                                      C_NOTAFISCAL.CDFORNECED, C_NOTAFISCAL.CDCLIENTE, C_NOTAFISCAL.DTEMISSAO, -1, V_CONTAATIV, 'S', C_IMPOSTO.VRIMPOSTONF);
                           ELSE
                              IF NOT ((C_NOTAFISCAL.IDOPERDEVONF = 'S') AND (C_NOTAFISCAL.IDCONTCONFORIG = 'N')) THEN
                                 NUMEROPARTIDA(C_NOTAFISCAL.CDEMPRESA, C_NOTAFISCAL.IDORIGDESTNF, C_NOTAFISCAL.CDFORNECED, C_NOTAFISCAL.CDCLIENTE);
                                 PARTIDA(C_NOTAFISCAL.CDEMPRESA, C_NOTAFISCAL.CDFILIAL, C_NOTAFISCAL.CDFILIRECE, C_NOTAFISCAL.CDFILIEMIT, C_NOTAFISCAL.NRLANCTONF,
                                         C_NOTAFISCAL.NRNOTAFISC, C_NOTAFISCAL.IDENTRSAIDOP, C_NOTAFISCAL.IDORIGDESTNF,
                                         C_NOTAFISCAL.CDFORNECED, C_NOTAFISCAL.CDCLIENTE, C_NOTAFISCAL.DTEMISSAO, 1, V_CONTAATIV, 'S', C_IMPOSTO.VRIMPOSTONF);
                              ELSE
                                 IF ((C_NOTAFISCAL.IDOPERDEVONF = 'S') AND (C_NOTAFISCAL.IDCONTCONFORIG = 'N')) THEN
                                    NUMEROPARTIDA(C_NOTAFISCAL.CDEMPRESA, C_NOTAFISCAL.IDORIGDESTNF, C_NOTAFISCAL.CDFORNECED, C_NOTAFISCAL.CDCLIENTE);
                                    PARTIDA(C_NOTAFISCAL.CDEMPRESA, C_NOTAFISCAL.CDFILIAL, C_NOTAFISCAL.CDFILIRECE, C_NOTAFISCAL.CDFILIEMIT, C_NOTAFISCAL.NRLANCTONF,
                                            C_NOTAFISCAL.NRNOTAFISC, C_NOTAFISCAL.IDENTRSAIDOP, C_NOTAFISCAL.IDORIGDESTNF,
                                            C_NOTAFISCAL.CDFORNECED, C_NOTAFISCAL.CDCLIENTE, C_NOTAFISCAL.DTEMISSAO, 1, V_CONTAPASS, 'S', C_IMPOSTO.VRIMPOSTONF);
                                 END IF;
                              END IF;
                           END IF;
                        END IF;
                     END IF;
                  END IF;
               END IF;
            END IF;
         END LOOP;
      ELSE
         FOR C_IMPOSTO IN
            (SELECT IMP.CDIMPOSTO, I.IDTRATIMPO,  I.IDIMPORECUP, IMP.IDTRIMPOSTNF, I.IDACRPRODENTRNF,
                    ROUND(SUM(IMP.VRIMPOSTONF),    2) AS VRIMPOSTONF,
                    ROUND(SUM(IMP.VRIMPCARGATRIBI),2) AS VRIMPCARGATRIBI,
                    CDCONTATIV,
                    CDCONTPASS,
                    CDCONTDESP
               FROM IMPOSTONF IMP, NOTAFISCAL NF, IMPOSTO I, PARAMFILIAL PF,
                    (SELECT DISTINCT CDIMPOSTO,
                                     CONTCTBL_IMPOSTO(I.CDIMPOSTO, 'A', 'S', NF.CDTIPOOPER, NF.IDTPIJURNF) AS CDCONTATIV,
                                     CONTCTBL_IMPOSTO(I.CDIMPOSTO, 'P', 'S', NF.CDTIPOOPER, NF.IDTPIJURNF) AS CDCONTPASS,
                                     CONTCTBL_IMPOSTO(I.CDIMPOSTO, 'D', 'S', NF.CDTIPOOPER, NF.IDTPIJURNF) AS CDCONTDESP
                       FROM IMPOSTONF I, NOTAFISCAL NF
                      WHERE I.CDFILIAL   = NF.CDFILIAL
                        AND I.NRLANCTONF = NF.NRLANCTONF
                        AND I.CDFILIAL   = P_CDFILIAL
                        AND I.NRLANCTONF = P_NRLANCTONF) CT
              WHERE IMP.VRIMPOSTONF > 0          AND
                    IMP.CDIMPOSTO = CT.CDIMPOSTO AND
                    IMP.CDIMPOSTO = I.CDIMPOSTO  AND
                    ((IMP.IDIMPOSTONF IN ('1','4')) OR (IMP.IDIMPOSTONF IS NULL)) AND
                    I.IDTIPCONTAB  = 'D'         AND
                    ((((I.IDIMPORECUP  = 'S'  AND IMP.CDFISCALNF = '1' AND PF.IDCARACFIS  = 'C') OR (PF.IDCARACFIS = 'A')) AND (CT.CDCONTPASS IS NOT NULL))
                     OR
                     ((I.IDIMPORECUP <> 'S') AND (CT.CDCONTPASS IS NOT NULL)))     AND
                    NF.CDFILIAL     = P_CDFILIAL      AND
                    NF.NRLANCTONF   = P_NRLANCTONF    AND
                    NF.CDFILIEMIT   = PF.CDFILIAL    AND
                    NF.CDFILIAL     = IMP.CDFILIAL   AND
                    NF.NRLANCTONF   = IMP.NRLANCTONF
              GROUP BY IMP.CDIMPOSTO, I.IDTRATIMPO,  I.IDIMPORECUP, IMP.IDTRIMPOSTNF, I.IDACRPRODENTRNF,
                           CDCONTPASS, CDCONTATIV, CDCONTDESP) LOOP
            IF C_IMPOSTO.VRIMPOSTONF > 0 THEN
               BEGIN
                  SELECT CDIMPOSTO
                    INTO V_IMPOSCARGATRIB
                    FROM IMPOSTO
                   WHERE CDIMPCARGATRIB = C_IMPOSTO.CDIMPOSTO;

               EXCEPTION
                  WHEN NO_DATA_FOUND THEN
                     V_IMPOSCARGATRIB := NULL;
               END;

               V_CONTAATIV := C_IMPOSTO.CDCONTATIV;
               V_CONTAATIV := CTB_CCTBL_IMPFIL(C_NOTAFISCAL.CDFILIEMIT, C_NOTAFISCAL.IDENTRSAIDOP, C_NOTAFISCAL.CDTIPOOPER, C_IMPOSTO.CDIMPOSTO, V_CONTAATIV, 'A');

               V_CONTAPASS := C_IMPOSTO.CDCONTPASS;
               V_CONTAPASS := CTB_CCTBL_IMPFIL(C_NOTAFISCAL.CDFILIEMIT, C_NOTAFISCAL.IDENTRSAIDOP, C_NOTAFISCAL.CDTIPOOPER, C_IMPOSTO.CDIMPOSTO, V_CONTAPASS, 'P');

               V_CONTADESP := C_IMPOSTO.CDCONTDESP;
               V_CONTADESP := CTB_CCTBL_IMPFIL(C_NOTAFISCAL.CDFILIEMIT, C_NOTAFISCAL.IDENTRSAIDOP, C_NOTAFISCAL.CDTIPOOPER, C_IMPOSTO.CDIMPOSTO, V_CONTADESP, 'D');

               IF C_NOTAFISCAL.IDOPERDEVONF <> 'S' THEN
                  BEGIN
                     SELECT MAX(CDIMPOSTO) AS CDIMPOSTRIB
                       INTO V_CDIMPOSUBST
                       FROM IMPOSTO
                      WHERE CDIMPOSTRIB = C_IMPOSTO.CDIMPOSTO;
                  EXCEPTION
                     WHEN NO_DATA_FOUND THEN
                        V_CDIMPOSUBST := NULL;
                  END;
                  IF V_CDIMPOSUBST IS NOT NULL THEN /* SUBSTITUIO TRIBUTRIA */
                     NUMEROPARTIDA(C_NOTAFISCAL.CDEMPRESA, C_NOTAFISCAL.IDORIGDESTNF, C_NOTAFISCAL.CDFORNECED, C_NOTAFISCAL.CDCLIENTE);
                     PARTIDA(C_NOTAFISCAL.CDEMPRESA, C_NOTAFISCAL.CDFILIAL, C_NOTAFISCAL.CDFILIRECE, C_NOTAFISCAL.CDFILIEMIT, C_NOTAFISCAL.NRLANCTONF,
                             C_NOTAFISCAL.NRNOTAFISC, C_NOTAFISCAL.IDENTRSAIDOP, C_NOTAFISCAL.IDORIGDESTNF,
                             C_NOTAFISCAL.CDFORNECED, C_NOTAFISCAL.CDCLIENTE, C_NOTAFISCAL.DTEMISSAO, 1, V_CONTAPASS, 'S', C_IMPOSTO.VRIMPOSTONF);
                     NUMEROPARTIDA(C_NOTAFISCAL.CDEMPRESA, C_NOTAFISCAL.IDORIGDESTNF, C_NOTAFISCAL.CDFORNECED, C_NOTAFISCAL.CDCLIENTE);
                     PARTIDA(C_NOTAFISCAL.CDEMPRESA, C_NOTAFISCAL.CDFILIAL, C_NOTAFISCAL.CDFILIRECE, C_NOTAFISCAL.CDFILIEMIT, C_NOTAFISCAL.NRLANCTONF,
                             C_NOTAFISCAL.NRNOTAFISC, C_NOTAFISCAL.IDENTRSAIDOP, C_NOTAFISCAL.IDORIGDESTNF,
                             C_NOTAFISCAL.CDFORNECED, C_NOTAFISCAL.CDCLIENTE, C_NOTAFISCAL.DTEMISSAO, -1, V_CONTADESP, 'S', C_IMPOSTO.VRIMPOSTONF);
                  ELSE
                     IF C_IMPOSTO.IDTRIMPOSTNF IS NOT NULL THEN
                        IF C_IMPOSTO.IDTRIMPOSTNF = '0' THEN
                           NUMEROPARTIDA(C_NOTAFISCAL.CDEMPRESA, C_NOTAFISCAL.IDORIGDESTNF, C_NOTAFISCAL.CDFORNECED, C_NOTAFISCAL.CDCLIENTE);
                           PARTIDA(C_NOTAFISCAL.CDEMPRESA, C_NOTAFISCAL.CDFILIAL, C_NOTAFISCAL.CDFILIRECE, C_NOTAFISCAL.CDFILIEMIT, C_NOTAFISCAL.NRLANCTONF,
                                   C_NOTAFISCAL.NRNOTAFISC, C_NOTAFISCAL.IDENTRSAIDOP, C_NOTAFISCAL.IDORIGDESTNF,
                                   C_NOTAFISCAL.CDFORNECED, C_NOTAFISCAL.CDCLIENTE, C_NOTAFISCAL.DTEMISSAO, 1, V_CONTAPASS, 'S', C_IMPOSTO.VRIMPOSTONF);
                        ELSE
                           NUMEROPARTIDA(C_NOTAFISCAL.CDEMPRESA, C_NOTAFISCAL.IDORIGDESTNF, C_NOTAFISCAL.CDFORNECED, C_NOTAFISCAL.CDCLIENTE);
                           PARTIDA(C_NOTAFISCAL.CDEMPRESA, C_NOTAFISCAL.CDFILIAL, C_NOTAFISCAL.CDFILIRECE, C_NOTAFISCAL.CDFILIEMIT, C_NOTAFISCAL.NRLANCTONF,
                                   C_NOTAFISCAL.NRNOTAFISC, C_NOTAFISCAL.IDENTRSAIDOP, C_NOTAFISCAL.IDORIGDESTNF,
                                   C_NOTAFISCAL.CDFORNECED, C_NOTAFISCAL.CDCLIENTE, C_NOTAFISCAL.DTEMISSAO, 1, V_CONTAPASS, 'S', C_IMPOSTO.VRIMPOSTONF);
                           NUMEROPARTIDA(C_NOTAFISCAL.CDEMPRESA, C_NOTAFISCAL.IDORIGDESTNF, C_NOTAFISCAL.CDFORNECED, C_NOTAFISCAL.CDCLIENTE);
                           PARTIDA(C_NOTAFISCAL.CDEMPRESA, C_NOTAFISCAL.CDFILIAL, C_NOTAFISCAL.CDFILIRECE, C_NOTAFISCAL.CDFILIEMIT, C_NOTAFISCAL.NRLANCTONF,
                                   C_NOTAFISCAL.NRNOTAFISC, C_NOTAFISCAL.IDENTRSAIDOP, C_NOTAFISCAL.IDORIGDESTNF,
                                   C_NOTAFISCAL.CDFORNECED, C_NOTAFISCAL.CDCLIENTE, C_NOTAFISCAL.DTEMISSAO, -1, V_CONTADESP, 'S', C_IMPOSTO.VRIMPOSTONF);
                        END IF;
                     ELSE
                        IF C_IMPOSTO.IDTRATIMPO = 'R' THEN
                           NUMEROPARTIDA(C_NOTAFISCAL.CDEMPRESA, C_NOTAFISCAL.IDORIGDESTNF, C_NOTAFISCAL.CDFORNECED, C_NOTAFISCAL.CDCLIENTE);
                           PARTIDA(C_NOTAFISCAL.CDEMPRESA, C_NOTAFISCAL.CDFILIAL, C_NOTAFISCAL.CDFILIRECE, C_NOTAFISCAL.CDFILIEMIT, C_NOTAFISCAL.NRLANCTONF,
                                   C_NOTAFISCAL.NRNOTAFISC, C_NOTAFISCAL.IDENTRSAIDOP, C_NOTAFISCAL.IDORIGDESTNF,
                                   C_NOTAFISCAL.CDFORNECED, C_NOTAFISCAL.CDCLIENTE, C_NOTAFISCAL.DTEMISSAO, -1, V_CONTAATIV, 'S', C_IMPOSTO.VRIMPOSTONF);
                        ELSE
                           IF C_IMPOSTO.IDTRATIMPO = 'A' THEN
                              NUMEROPARTIDA(C_NOTAFISCAL.CDEMPRESA, C_NOTAFISCAL.IDORIGDESTNF, C_NOTAFISCAL.CDFORNECED, C_NOTAFISCAL.CDCLIENTE);
                              PARTIDA(C_NOTAFISCAL.CDEMPRESA, C_NOTAFISCAL.CDFILIAL, C_NOTAFISCAL.CDFILIRECE, C_NOTAFISCAL.CDFILIEMIT, C_NOTAFISCAL.NRLANCTONF,
                                   C_NOTAFISCAL.NRNOTAFISC, C_NOTAFISCAL.IDENTRSAIDOP, C_NOTAFISCAL.IDORIGDESTNF,
                                   C_NOTAFISCAL.CDFORNECED, C_NOTAFISCAL.CDCLIENTE, C_NOTAFISCAL.DTEMISSAO, 1, V_CONTAPASS, 'S', C_IMPOSTO.VRIMPOSTONF);
                              /* Verifica se o imposto  recupervel
                                 para contabilizar uma partida na Receita e outra na Despesa. */
                              FOR C_ITEMPROIMPOSIPI IN
                                 (SELECT ROUND(VRIMPOSTOIT, 2) VRIMPOSTOIT, IT.CDPRODUTO, CONTCTBL_PRODUTO(IT.CDPRODUTO, 'S', NF.CDFILIEMIT) AS CDCTBLSAIDPR,
                                         CONTCTBL_PRODUTO(IT.CDPRODUTO, 'E', NF.CDFILIEMIT) CDCTBLENTRPR
                                    FROM ITEMPROIMPOS IMP, (SELECT DISTINCT CDIMPOSTO,
                                                                            CONTCTBL_IMPOSTO(I.CDIMPOSTO, 'A', C_NOTAFISCAL.IDENTRSAIDOP, NF.CDTIPOOPER, NF.IDTPIJURNF) AS CDCONTATIV,
                                                                            CONTCTBL_IMPOSTO(I.CDIMPOSTO, 'P', C_NOTAFISCAL.IDENTRSAIDOP, NF.CDTIPOOPER, NF.IDTPIJURNF) AS CDCONTPASS,
                                                                            CONTCTBL_IMPOSTO(I.CDIMPOSTO, 'D', C_NOTAFISCAL.IDENTRSAIDOP, NF.CDTIPOOPER, NF.IDTPIJURNF) AS CDCONTDESP
                                                              FROM ITEMPROIMPOS I, NOTAFISCAL NF
                                                             WHERE I.CDFILIAL   = NF.CDFILIAL
                                                               AND I.NRLANCTONF = NF.NRLANCTONF
                                                               AND I.CDFILIAL   = P_CDFILIAL
                                                               AND I.NRLANCTONF = P_NRLANCTONF) CT, IMPOSTO I, PARAMFILIAL PF, NOTAFISCAL NF, ITEMPRODUTO IT
                                   WHERE IMP.NRLANCTONF = P_NRLANCTONF
                                     AND IMP.CDFILIAL = P_CDFILIAL
                                     AND IMP.VRIMPOSTOIT > 0
                                     AND IMP.CDIMPOSTO = CT.CDIMPOSTO
                                     AND IMP.CDIMPOSTO = I.CDIMPOSTO
                                     AND ((IMP.NRITPROIMPOS IN ('1','4')) OR (IMP.NRITPROIMPOS IS NULL))
                                     AND I.IDTIPCONTAB  = 'D'
                                     AND CT.CDCONTPASS IS NOT NULL
                                     AND IMP.CDFILIAL = NF.CDFILIAL
                                     AND IMP.NRLANCTONF = NF.NRLANCTONF
                                     AND IMP.CDFILIAL = IT.CDFILIAL
                                     AND IMP.NRLANCTONF = IT.NRLANCTONF
                                     AND I.CDIMPOSTO = C_IMPOSTO.CDIMPOSTO
                                     AND DECODE(NF.IDENTRSAIDOP, 'E', NF.CDFILIRECE, NF.CDFILIEMIT) = PF.CDFILIAL
                                     AND IT.NRSEQITPROD = IMP.NRSEQITPROD
                                     AND I.IDTRATIMPO = 'A'
                                     AND I.IDIMPORECUP = 'S') LOOP

                                 IF C_NOTAFISCAL.IDCONTSOMENIMPO = 'N' THEN
                                    V_CDCONTPROD := CONTAPRODUTOIPI(C_ITEMPROIMPOSIPI.CDPRODUTO, 'S', C_NOTAFISCAL.CDTIPOOPER, C_NOTAFISCAL.CDFILIEMIT);

                                    NUMEROPARTIDA(C_NOTAFISCAL.CDEMPRESA, C_NOTAFISCAL.IDORIGDESTNF, C_NOTAFISCAL.CDFORNECED, C_NOTAFISCAL.CDCLIENTE);
                                    PARTIDA(C_NOTAFISCAL.CDEMPRESA, C_NOTAFISCAL.CDFILIAL, C_NOTAFISCAL.CDFILIRECE, C_NOTAFISCAL.CDFILIEMIT, C_NOTAFISCAL.NRLANCTONF,
                                            C_NOTAFISCAL.NRNOTAFISC, C_NOTAFISCAL.IDENTRSAIDOP, C_NOTAFISCAL.IDORIGDESTNF,
                                            C_NOTAFISCAL.CDFORNECED, C_NOTAFISCAL.CDCLIENTE, C_NOTAFISCAL.DTEMISSAO, 1, V_CDCONTPROD, 'S', C_ITEMPROIMPOSIPI.VRIMPOSTOIT);
                                 END IF;
                                 NUMEROPARTIDA(C_NOTAFISCAL.CDEMPRESA, C_NOTAFISCAL.IDORIGDESTNF, C_NOTAFISCAL.CDFORNECED, C_NOTAFISCAL.CDCLIENTE);
                                 PARTIDA(C_NOTAFISCAL.CDEMPRESA, C_NOTAFISCAL.CDFILIAL, C_NOTAFISCAL.CDFILIRECE, C_NOTAFISCAL.CDFILIEMIT, C_NOTAFISCAL.NRLANCTONF,
                                         C_NOTAFISCAL.NRNOTAFISC, C_NOTAFISCAL.IDENTRSAIDOP, C_NOTAFISCAL.IDORIGDESTNF,
                                         C_NOTAFISCAL.CDFORNECED, C_NOTAFISCAL.CDCLIENTE, C_NOTAFISCAL.DTEMISSAO, -1, V_CONTADESP, 'S', C_ITEMPROIMPOSIPI.VRIMPOSTOIT);

                              END LOOP;
                           ELSE
                              IF C_IMPOSTO.IDTRATIMPO = 'D' THEN
                                 NUMEROPARTIDA(C_NOTAFISCAL.CDEMPRESA, C_NOTAFISCAL.IDORIGDESTNF, C_NOTAFISCAL.CDFORNECED, C_NOTAFISCAL.CDCLIENTE);
                                 PARTIDA(C_NOTAFISCAL.CDEMPRESA, C_NOTAFISCAL.CDFILIAL, C_NOTAFISCAL.CDFILIRECE, C_NOTAFISCAL.CDFILIEMIT, C_NOTAFISCAL.NRLANCTONF,
                                         C_NOTAFISCAL.NRNOTAFISC, C_NOTAFISCAL.IDENTRSAIDOP, C_NOTAFISCAL.IDORIGDESTNF,
                                         C_NOTAFISCAL.CDFORNECED, C_NOTAFISCAL.CDCLIENTE, C_NOTAFISCAL.DTEMISSAO, -1, V_CONTAATIV, 'S', C_IMPOSTO.VRIMPOSTONF);
                              ELSE
                                 IF C_NOTAFISCAL.IDORIGDESTNF = 'L' THEN
                                    NUMEROPARTIDA(C_NOTAFISCAL.CDEMPRESA, C_NOTAFISCAL.IDORIGDESTNF, C_NOTAFISCAL.CDFORNECED, C_NOTAFISCAL.CDCLIENTE);
                                    PARTIDA(C_NOTAFISCAL.CDEMPRESA, C_NOTAFISCAL.CDFILIAL, C_NOTAFISCAL.CDFILIRECE, C_NOTAFISCAL.CDFILIEMIT, C_NOTAFISCAL.NRLANCTONF,
                                            C_NOTAFISCAL.NRNOTAFISC, C_NOTAFISCAL.IDENTRSAIDOP, C_NOTAFISCAL.IDORIGDESTNF,
                                            C_NOTAFISCAL.CDFORNECED, C_NOTAFISCAL.CDCLIENTE, C_NOTAFISCAL.DTEMISSAO, 1, V_CONTAPASS, 'S', C_IMPOSTO.VRIMPOSTONF);
                                 ELSE
                                    IF C_IMPOSTO.VRIMPCARGATRIBI > 0 THEN
                                       NUMEROPARTIDA(C_NOTAFISCAL.CDEMPRESA, C_NOTAFISCAL.IDORIGDESTNF, C_NOTAFISCAL.CDFORNECED, C_NOTAFISCAL.CDCLIENTE);
                                       PARTIDA(C_NOTAFISCAL.CDEMPRESA, C_NOTAFISCAL.CDFILIAL, C_NOTAFISCAL.CDFILIRECE, C_NOTAFISCAL.CDFILIEMIT, C_NOTAFISCAL.NRLANCTONF,
                                               C_NOTAFISCAL.NRNOTAFISC, C_NOTAFISCAL.IDENTRSAIDOP, C_NOTAFISCAL.IDORIGDESTNF,
                                               C_NOTAFISCAL.CDFORNECED, C_NOTAFISCAL.CDCLIENTE, C_NOTAFISCAL.DTEMISSAO, 1, V_CONTAPASS, 'S', C_IMPOSTO.VRIMPCARGATRIBI);

                                       NUMEROPARTIDA(C_NOTAFISCAL.CDEMPRESA, C_NOTAFISCAL.IDORIGDESTNF, C_NOTAFISCAL.CDFORNECED, C_NOTAFISCAL.CDCLIENTE);
                                       PARTIDA(C_NOTAFISCAL.CDEMPRESA, C_NOTAFISCAL.CDFILIAL, C_NOTAFISCAL.CDFILIRECE, C_NOTAFISCAL.CDFILIEMIT, C_NOTAFISCAL.NRLANCTONF,
                                               C_NOTAFISCAL.NRNOTAFISC, C_NOTAFISCAL.IDENTRSAIDOP, C_NOTAFISCAL.IDORIGDESTNF,
                                               C_NOTAFISCAL.CDFORNECED, C_NOTAFISCAL.CDCLIENTE, C_NOTAFISCAL.DTEMISSAO, -1, V_CONTADESP, 'S', C_IMPOSTO.VRIMPCARGATRIBI);
                                    ELSE
                                       IF V_IMPOSCARGATRIB IS NULL THEN
                                          NUMEROPARTIDA(C_NOTAFISCAL.CDEMPRESA, C_NOTAFISCAL.IDORIGDESTNF, C_NOTAFISCAL.CDFORNECED, C_NOTAFISCAL.CDCLIENTE);
                                          PARTIDA(C_NOTAFISCAL.CDEMPRESA, C_NOTAFISCAL.CDFILIAL, C_NOTAFISCAL.CDFILIRECE, C_NOTAFISCAL.CDFILIEMIT, C_NOTAFISCAL.NRLANCTONF,
                                                  C_NOTAFISCAL.NRNOTAFISC, C_NOTAFISCAL.IDENTRSAIDOP, C_NOTAFISCAL.IDORIGDESTNF,
                                                  C_NOTAFISCAL.CDFORNECED, C_NOTAFISCAL.CDCLIENTE, C_NOTAFISCAL.DTEMISSAO, 1, V_CONTAPASS, 'S', C_IMPOSTO.VRIMPOSTONF);

                                          NUMEROPARTIDA(C_NOTAFISCAL.CDEMPRESA, C_NOTAFISCAL.IDORIGDESTNF, C_NOTAFISCAL.CDFORNECED, C_NOTAFISCAL.CDCLIENTE);
                                          PARTIDA(C_NOTAFISCAL.CDEMPRESA, C_NOTAFISCAL.CDFILIAL, C_NOTAFISCAL.CDFILIRECE, C_NOTAFISCAL.CDFILIEMIT, C_NOTAFISCAL.NRLANCTONF,
                                                  C_NOTAFISCAL.NRNOTAFISC, C_NOTAFISCAL.IDENTRSAIDOP, C_NOTAFISCAL.IDORIGDESTNF,
                                                  C_NOTAFISCAL.CDFORNECED, C_NOTAFISCAL.CDCLIENTE, C_NOTAFISCAL.DTEMISSAO, -1, V_CONTADESP, 'S', C_IMPOSTO.VRIMPOSTONF);
                                       ELSE
                                          BEGIN
                                             SELECT INF.VRIMPCARGATRIBI
                                               INTO V_VRCARGATRIB
                                               FROM IMPOSTONF INF, IMPOSTO I
                                              WHERE INF.CDIMPOSTO  = V_IMPOSCARGATRIB
                                                AND INF.NRLANCTONF = P_NRLANCTONF
                                                AND INF.CDFILIAL   = P_CDFILIAL
                                                AND I.CDIMPOSTO = INF.CDIMPOSTO
                                                AND INF.VRIMPCARGATRIBI > 0;
                                          EXCEPTION
                                             WHEN NO_DATA_FOUND THEN
                                                V_VRCARGATRIB := 0;
                                          END;

                                          V_CONTAPASS := CTB_CCTBL_IMPFIL(C_NOTAFISCAL.CDFILIEMIT, C_NOTAFISCAL.IDENTRSAIDOP, C_NOTAFISCAL.CDTIPOOPER, V_IMPOSCARGATRIB, V_CONTAPASS, 'P');
                                          NUMEROPARTIDA(C_NOTAFISCAL.CDEMPRESA, C_NOTAFISCAL.IDORIGDESTNF, C_NOTAFISCAL.CDFORNECED, C_NOTAFISCAL.CDCLIENTE);
                                          PARTIDA(C_NOTAFISCAL.CDEMPRESA, C_NOTAFISCAL.CDFILIAL, C_NOTAFISCAL.CDFILIRECE, C_NOTAFISCAL.CDFILIEMIT, C_NOTAFISCAL.NRLANCTONF,
                                                  C_NOTAFISCAL.NRNOTAFISC, C_NOTAFISCAL.IDENTRSAIDOP, C_NOTAFISCAL.IDORIGDESTNF,
                                                  C_NOTAFISCAL.CDFORNECED, C_NOTAFISCAL.CDCLIENTE, C_NOTAFISCAL.DTEMISSAO, 1, V_CONTAPASS, 'S', V_VRCARGATRIB);

                                          V_CONTADESP := CTB_CCTBL_IMPFIL(C_NOTAFISCAL.CDFILIEMIT, C_NOTAFISCAL.IDENTRSAIDOP, C_NOTAFISCAL.CDTIPOOPER, V_IMPOSCARGATRIB, V_CONTADESP, 'D');
                                          NUMEROPARTIDA(C_NOTAFISCAL.CDEMPRESA, C_NOTAFISCAL.IDORIGDESTNF, C_NOTAFISCAL.CDFORNECED, C_NOTAFISCAL.CDCLIENTE);
                                          PARTIDA(C_NOTAFISCAL.CDEMPRESA, C_NOTAFISCAL.CDFILIAL, C_NOTAFISCAL.CDFILIRECE, C_NOTAFISCAL.CDFILIEMIT, C_NOTAFISCAL.NRLANCTONF,
                                                  C_NOTAFISCAL.NRNOTAFISC, C_NOTAFISCAL.IDENTRSAIDOP, C_NOTAFISCAL.IDORIGDESTNF,
                                                  C_NOTAFISCAL.CDFORNECED, C_NOTAFISCAL.CDCLIENTE, C_NOTAFISCAL.DTEMISSAO, -1, V_CONTADESP, 'S', V_VRCARGATRIB);
                                       END IF;
                                    END IF;
                                 END IF;
                              END IF;
                           END IF;
                        END IF;
                     END IF;
                  END IF;
               ELSE
                  /* NOTAS FISCAIS DE DEVOLUO PARA FORNECEDOR */
                  BEGIN
                     SELECT MAX(CDIMPOSTO) AS CDIMPOSTRIB
                       INTO V_CDIMPOSUBST
                       FROM IMPOSTO
                      WHERE CDIMPOSTRIB = C_IMPOSTO.CDIMPOSTO;
                  EXCEPTION
                     WHEN NO_DATA_FOUND THEN
                        V_CDIMPOSUBST := NULL;
                  END;

                  IF ((C_IMPOSTO.IDTRATIMPO = 'A') AND (C_IMPOSTO.IDIMPORECUP <> 'S')) THEN
                     NUMEROPARTIDA(C_NOTAFISCAL.CDEMPRESA, C_NOTAFISCAL.IDORIGDESTNF, C_NOTAFISCAL.CDFORNECED, C_NOTAFISCAL.CDCLIENTE);
                     PARTIDA(C_NOTAFISCAL.CDEMPRESA, C_NOTAFISCAL.CDFILIAL, C_NOTAFISCAL.CDFILIRECE, C_NOTAFISCAL.CDFILIEMIT, C_NOTAFISCAL.NRLANCTONF,
                             C_NOTAFISCAL.NRNOTAFISC, C_NOTAFISCAL.IDENTRSAIDOP, C_NOTAFISCAL.IDORIGDESTNF,
                             C_NOTAFISCAL.CDFORNECED, C_NOTAFISCAL.CDCLIENTE, C_NOTAFISCAL.DTEMISSAO, 1, V_CONTADESP, 'S', C_IMPOSTO.VRIMPOSTONF);
                  ELSE
                     IF ((C_IMPOSTO.IDTRATIMPO = 'A') AND (C_IMPOSTO.IDIMPORECUP = 'S')) THEN
                        NUMEROPARTIDA(C_NOTAFISCAL.CDEMPRESA, C_NOTAFISCAL.IDORIGDESTNF, C_NOTAFISCAL.CDFORNECED, C_NOTAFISCAL.CDCLIENTE);
                        PARTIDA(C_NOTAFISCAL.CDEMPRESA, C_NOTAFISCAL.CDFILIAL, C_NOTAFISCAL.CDFILIRECE, C_NOTAFISCAL.CDFILIEMIT, C_NOTAFISCAL.NRLANCTONF,
                                C_NOTAFISCAL.NRNOTAFISC, C_NOTAFISCAL.IDENTRSAIDOP, C_NOTAFISCAL.IDORIGDESTNF,
                                C_NOTAFISCAL.CDFORNECED, C_NOTAFISCAL.CDCLIENTE, C_NOTAFISCAL.DTEMISSAO, 1, V_CONTAATIV, 'S', C_IMPOSTO.VRIMPOSTONF);
                     ELSE
                        IF (C_IMPOSTO.IDTRATIMPO = 'R') THEN
                           NUMEROPARTIDA(C_NOTAFISCAL.CDEMPRESA, C_NOTAFISCAL.IDORIGDESTNF, C_NOTAFISCAL.CDFORNECED, C_NOTAFISCAL.CDCLIENTE);
                           PARTIDA(C_NOTAFISCAL.CDEMPRESA, C_NOTAFISCAL.CDFILIAL, C_NOTAFISCAL.CDFILIRECE, C_NOTAFISCAL.CDFILIEMIT, C_NOTAFISCAL.NRLANCTONF,
                                   C_NOTAFISCAL.NRNOTAFISC, C_NOTAFISCAL.IDENTRSAIDOP, C_NOTAFISCAL.IDORIGDESTNF,
                                   C_NOTAFISCAL.CDFORNECED, C_NOTAFISCAL.CDCLIENTE, C_NOTAFISCAL.DTEMISSAO, -1, V_CONTAATIV, 'S', C_IMPOSTO.VRIMPOSTONF);
                        ELSE
                           NUMEROPARTIDA(C_NOTAFISCAL.CDEMPRESA, C_NOTAFISCAL.IDORIGDESTNF, C_NOTAFISCAL.CDFORNECED, C_NOTAFISCAL.CDCLIENTE);
                           PARTIDA(C_NOTAFISCAL.CDEMPRESA, C_NOTAFISCAL.CDFILIAL, C_NOTAFISCAL.CDFILIRECE, C_NOTAFISCAL.CDFILIEMIT, C_NOTAFISCAL.NRLANCTONF,
                                   C_NOTAFISCAL.NRNOTAFISC, C_NOTAFISCAL.IDENTRSAIDOP, C_NOTAFISCAL.IDORIGDESTNF,
                                   C_NOTAFISCAL.CDFORNECED, C_NOTAFISCAL.CDCLIENTE, C_NOTAFISCAL.DTEMISSAO, 1, V_CONTAATIV, 'S', C_IMPOSTO.VRIMPOSTONF);
                        END IF;
                     END IF;
                  END IF;
               END IF;
            END IF;
         END LOOP;
      END IF;
   END LOOP;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('CTB_DFS_IMPOSTO','6.49.040'); END;
/


